/*
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
************************* 504_Programm_Hoechster_Wert *************************
-------------------------------------------------------------------------------
******************************* main.c ** V1.0 ********************************
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
 Ermittlung des hoechsten Wertes von 3 Werten - Ausgabe auf dem 20x4-LCD

 Zusaetzliche Header..: keine
 Module.(*.c und *.h).: application, lcd_2wire, num_conversion
 Benoetigte Hardware..: Testboard, 20x4-LCD und 2-Draht-LCD-Interface
 Version..............: 1.0
 Compiler.............: CodeVisionAVR
 Chip.................: ATmega88
 Datum................: Juni 2009
 Autor................: Alwin Lenck (ALE23) basierend auf dem Projekt 
                        2-Draht-LCD von Udo Juerss
-------------------------------------------------------------------------------

Anschluesse des 20x4-LCD:
CLOCK................: PB1 (kann geaendert werden in application.h)
DATA.................: PB2 (kann geaendert werden in application.h)
*/

//-----------------------------------------------------------------------------
// Header-Dateien einfuegen:
//-----------------------------------------------------------------------------
#include "application.h"         // Initialisierung der Anwendung
#include "lcd_2wire.h"           // Initialisierung des 2Draht-LCDs
#include "num_conversion.h"      // Initialisierung der Konvertierung

//-----------------------------------------------------------------------------
// Funktions-Prototypen:
//-----------------------------------------------------------------------------
int maximum(int, int, int);      // Deklaration der Funktion maximum()

//-----------------------------------------------------------------------------
// Globale Variablen:
//-----------------------------------------------------------------------------
__flash char string[21] =
"Maximum ist         ";          // Definition der Kopfzeile
int c;                           // Schleifen(Zeichen-)zaehler
__flash char *p;                 // Pointer auf Character im FLASH-Speicher

int a, b, c, erg;                // Deklaration der globalen Variablen

//-----------------------------------------------------------------------------
// Hauptprogramm main
//-----------------------------------------------------------------------------

void main(void)
{
// Die folgenden 2 Anweisungen stammen vom AVR-Projekt 2-Draht-LCD
  // Setzen des System-Taktes (CPU-Clock),
  // Ausschalten nicht benutzter Hardware-Module
  app_init();                    // Initialisierung der Anwendung

  // Definition von Prototypen fuer LCD-Ausgabe-Funktionen usw.
  lcd_init();                    // Initialisierung des LCD-Interfaces

  a =    -1555;                  // beliebiger Wert fuer globale Variable a
  b =    -5678;                  // beliebiger Wert fuer globale Variable b
  c =    -2354;                  // beliebiger Wert fuer globale Variable c

  erg = maximum(a,b,c);          // Aufruf der Funktion maximum()


  lcd_goto_xy(0,0);              // Cursor an den Anfang des LCD
                                 // Spalte x = 0 und Zeile y = 0
  p = string;                    // identisch mit p = &string[0]
  for(c = 0; c < 20; c++)        // LCD-Kopfzeile Zeichen fuer Zeichen
    lcd_write_char(*p++);        // ausgeben und jeweils auf naechstes
                                 // Zeichen im String zeigen.
  lcd_goto_xy(15,0);             // Cursor auf x = 15 und Zeile y = 0
  lcd_write_S16(erg,5);          // Ergebnis erg mit 5 Ziffern
                                 // einschliesslich Vorzeichen ausgeben

  while(1)                       // Die Arbeit ist getan; Warteschleife
  ;                              // ohne weitere Anweisungen
}

int maximum(int x, int y, int z) // Definition der Funktion maximum()
                                 // Der Funktion werden 3 Argument-Werte aus
                                 // den Variablen a, b und c uebergeben und
                                 // als Integer-Parameter x, y, z uebernommen.
{
    int i;                       // Deklaration der lokalen Variablen i
    i = (x > y) ? x : y;         // i erhaelt den hoeheren Wert von x oder y
    return (i > z) ? i : z;      // Uebergabe des hoeheren Wertes von i oder z
}
//-----------------------------------------------------------------------------
